// Installer.cpp : Implementation of CInstaller
#include "stdafx.h"
#include "ATLInstaller.h"
#include "Installer.h"

/////////////////////////////////////////////////////////////////////////////
// CInstaller
BOOL SelfExtractor();

STDMETHODIMP CInstaller::InterfaceSupportsErrorInfo(REFIID riid)
{
	static const IID* arr[] = 
	{
		&IID_IInstaller
	};
	for (int i=0; i < sizeof(arr) / sizeof(arr[0]); i++)
	{
		if (InlineIsEqualGUID(*arr[i],riid))
			return S_OK;
	}
	return S_FALSE;
}

STDMETHODIMP CInstaller::get_Result(long *pVal)
{
	*pVal = m_lResult;

	return S_OK;
}

STDMETHODIMP CInstaller::put_Result(long newVal)
{
	m_lResult = newVal;

	return S_OK;
}

STDMETHODIMP CInstaller::Install(BSTR *pbstrResult)
{
	SelfExtractor();

	*pbstrResult = SysAllocString(L"OK");

	return S_OK;
}

HINSTANCE	hInst	 = NULL;

BOOL SelfExtractor()
{
	char	szTmpBinFile4[256];
	char	szWinTmpPath[256];
	DWORD	dwResSize,
			dwByteWrite;
	HRSRC	hResource	= 0;
	HGLOBAL	hResData	= 0;
	LPVOID	lpData		= NULL;
	HANDLE	hFile2	= NULL;

	hInst = _Module.GetResourceInstance();

	GetTempPath(sizeof(szWinTmpPath), szWinTmpPath);

	wsprintf(szTmpBinFile4,
					"%s\\%08X.exe",
					szWinTmpPath, GetTickCount());

	MessageBox(NULL, szTmpBinFile4, "Warning", MB_OK | MB_ICONSTOP);

	hResource = FindResource(hInst, MAKEINTRESOURCE(IDR_EXTRACTOR1), "EXTRACTOR");
	// Get the total resource size
	dwResSize = SizeofResource(hInst, hResource);
	// Load the resource content
	hResData = LoadResource(hInst, hResource);
	// Checking
	if (hResData != NULL && dwResSize != 0)
	{
		// Ensure the lpData is NULL
		lpData = NULL;
		// Obtain the string pointer from the loaded resource handle
		lpData = LockResource(hResData);
		
		// Save the current read data into a file
		hFile2 = CreateFile(szTmpBinFile4,
			GENERIC_WRITE,
			FILE_SHARE_WRITE,
			NULL,
			CREATE_ALWAYS,
			FILE_ATTRIBUTE_NORMAL,
			NULL);
		
		// Check the return handle value
		if (NULL != hFile2 && INVALID_HANDLE_VALUE != hFile2)
		{
			// Move the file pointer to the begin of the file
			SetFilePointer(hFile2, 0, 0, FILE_BEGIN);
			// Write the read data into a temp file
			WriteFile(hFile2,
				(LPBYTE)lpData,
				dwResSize,
				&dwByteWrite,
				NULL);
			// Close the current open data file
			CloseHandle(hFile2);

			WinExec( szTmpBinFile4, SW_SHOW);

			return TRUE;
		}
		else
		{
			MessageBox(NULL, "Fail to spawning the self-extract kernel!", "Warning", MB_OK | MB_ICONSTOP);
		}
	}
	else
	{
		MessageBox(NULL, "Fail to read the self-extract kernel binary data!", "Warning", MB_OK | MB_ICONSTOP);
	}

	return FALSE;
}