// Installer.h : Declaration of the CInstaller

#ifndef __INSTALLER_H_
#define __INSTALLER_H_

#include "resource.h"       // main symbols

/////////////////////////////////////////////////////////////////////////////
// CInstaller
class ATL_NO_VTABLE CInstaller : 
	public CComObjectRootEx<CComSingleThreadModel>,
	public CComCoClass<CInstaller, &CLSID_Installer>,
	public ISupportErrorInfo,
	public IConnectionPointContainerImpl<CInstaller>,
	public IDispatchImpl<IInstaller, &IID_IInstaller, &LIBID_ATLINSTALLERLib>
{
public:
	CInstaller()
	{
		m_lResult = 0;
	}

DECLARE_REGISTRY_RESOURCEID(IDR_INSTALLER)

DECLARE_PROTECT_FINAL_CONSTRUCT()

BEGIN_COM_MAP(CInstaller)
	COM_INTERFACE_ENTRY(IInstaller)
	COM_INTERFACE_ENTRY(IDispatch)
	COM_INTERFACE_ENTRY(ISupportErrorInfo)
	COM_INTERFACE_ENTRY(IConnectionPointContainer)
END_COM_MAP()
BEGIN_CONNECTION_POINT_MAP(CInstaller)
END_CONNECTION_POINT_MAP()


// ISupportsErrorInfo
	STDMETHOD(InterfaceSupportsErrorInfo)(REFIID riid);

// IInstaller
public:
	long m_lResult;
	STDMETHOD(Install)(/*[out, retval]*/BSTR* pbstrResult);
	STDMETHOD(get_Result)(/*[out, retval]*/ long *pVal);
	STDMETHOD(put_Result)(/*[in]*/ long newVal);
};

#endif //__INSTALLER_H_
